# std::vector< _Tp, _Alloc > Class Template Reference
[Containers, Sequences]

A standard container which offers fixed time access to individual elements in any order. More...

`#include <stl_vector.h>`

List of all members.

## Public Methods

iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
size_type | max_size () const
size_type | capacity () const
bool | empty () const
reference | operator[] (size_type __n)
| Subscript access to the data contained in the vector. More...
const_reference | operator[] (size_type __n) const
| Subscript access to the data contained in the vector. More...
reference | at (size_type __n)
| Provides access to the data contained in the vector. More...
const_reference | at (size_type __n) const
| Provides access to the data contained in the vector. More...
void | reserve (size_type __n)
| Attempt to preallocate enough memory for specified number of elements. More...
void | assign (size_type __n, const _Tp &__val)
| Assigns a given value or range to a vector. More...
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push_back (const _Tp &__x)
| Add data to the end of the vector. More...
void | push_back ()
iterator | insert (iterator __position, const _Tp &__x)
| Inserts given value into vector at specified element. More...
iterator | insert (iterator __position)
| Inserts an empty element into the vector. More...
void | insert (iterator __pos, size_type __n, const _Tp &__x)
| Inserts a number of copies of given data into the vector. More...
void | pop_back ()
| Removes last element from vector. More...
iterator | erase (iterator __position)
| Remove element at given position. More...
iterator | erase (iterator __first, iterator __last)
| Remove a range of elements from a vector. More...
void | resize (size_type __new_size, const _Tp &__x)
| Resizes the vector to the specified number of elements. More...
void | resize (size_type __new_size)
| Resizes the vector to the specified number of elements. More...
void | clear ()

## Detailed Description

### template<class _Tp, class _Alloc = allocator<_Tp>>
class std::vector< _Tp, _Alloc >

A standard container which offers fixed time access to individual elements in any order.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the exception of `push_front` and `pop_front`.

In some terminology a vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( [] ) access is also provided as with C-style arrays.

Definition at line 166 of file stl_vector.h.

## Member Function Documentation

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const _Tp & | __val
| ) | `[inline]`

Assigns a given value or range to a vector.

Parameters:

  n | Number of elements to be assigned.
  val | Value to be assigned.

This function can be used to assign a range to a vector or fill it with a specified number of copies of the given value. Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 421 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the vector.

Parameters:

  n | The element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 328 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the vector.

Parameters:

  n | The element for which data should be accessed.

Returns:
  Read/write reference to data.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 316 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::back | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the vector. Definition at line 477 of file stl_vector.h. References std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::back | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the last element of the vector. Definition at line 471 of file stl_vector.h. References std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
const_iterator std::vector< _Tp, _Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first element in the vector. Iteration is done in ordinary element order. Definition at line 214 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first element in the vector. Iteration is done in ordinary element order.

Definition at line 208 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::capacity(), std::vector< _Tp, _Alloc >::clear(), std::vector< _Tp, _Alloc >::empty(), std::vector< _Tp, _Alloc >::front(), std::vector< _Tp, _Alloc >::insert(), std::vector< _Tp, _Alloc >::operator[](), std::vector< _Tp, _Alloc >::rend(), std::vector< _Tp, _Alloc >::resize(), and std::vector< _Tp, _Alloc >::size().

template<class _Tp, class _Alloc = allocator<_Tp>>
size_type std::vector< _Tp, _Alloc >::capacity | ( |  | ) | const`[inline]`

| Returns the amount of memory that has been alocated for the current elements (?). Definition at line 271 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin(). Referenced by std::vector< _Tp, _Alloc >::reserve().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::clear | ( |  | ) | `[inline]`

| Erases all elements in vector. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 709 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin(), std::vector< _Tp, _Alloc >::end(), and std::vector< _Tp, _Alloc >::erase().

template<class _Tp, class _Alloc = allocator<_Tp>>
bool std::vector< _Tp, _Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the vector is empty. (Thus begin() would equal end().) Definition at line 277 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin(), and std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
const_iterator std::vector< _Tp, _Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last element in the vector. Iteration is done in ordinary element order. Definition at line 227 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last element in the vector. Iteration is done in ordinary element order.

Definition at line 221 of file stl_vector.h.

Referenced by std::vector< _Tp, _Alloc >::back(), std::vector< _Tp, _Alloc >::clear(), std::vector< _Tp, _Alloc >::empty(), std::vector< _Tp, _Alloc >::erase(), std::vector< _Tp, _Alloc >::insert(), std::vector< _Tp, _Alloc >::push_back(), std::vector< _Tp, _Alloc >::rbegin(), std::vector< _Tp, _Alloc >::resize(), and std::vector< _Tp, _Alloc >::size().

template<class _Tp, class _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last
| ) | `[inline]`

Remove a range of elements from a vector.

Parameters:

  first | Iterator pointing to the first element to be erased.
  last | Iterator pointing to the last element to be erased.

Returns:
  Doc Me! (Iterator pointing to new element at old location?)

This function will erase the elements in the given range and shorten the vector accordingly.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 668 of file stl_vector.h.

References std::copy(), and std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::erase | ( | iterator | __position | ) | `[inline]`

Remove element at given position.

Parameters:

  position | Iterator pointing to element to be erased.

Returns:
  Doc Me! (Iterator pointing to new element at old location?)

This function will erase the element at the given position and thus shorten the vector by one.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 645 of file stl_vector.h.

References std::copy(), and std::vector< _Tp, _Alloc >::end().

Referenced by std::vector< _Tp, _Alloc >::clear(), and std::vector< _Tp, _Alloc >::resize().

template<class _Tp, class _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::front | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the vector. Definition at line 465 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin().

template<class _Tp, class _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::front | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the vector. Definition at line 459 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::insert | ( | iterator | __pos,
|  | size_type | __n,
|  | const _Tp & | __x
| ) | `[inline]`

Inserts a number of copies of given data into the vector.

Parameters:

  position | An iterator that points to the element where data should be inserted.
  n | Amount of elements to be inserted.
  x | Data to be inserted.

This function will insert a specified number of copies of the given data into the specified location.

Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 612 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::insert | ( | iterator | __position | ) | `[inline]`

Inserts an empty element into the vector.

Parameters:

  position | An iterator that points to the element where empty element should be inserted.
  x | Data to be inserted.

Returns:
  An iterator that points to the inserted element.

This function will insert an empty element into the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 563 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::begin(), and std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | const _Tp & | __x
| ) | `[inline]`

Inserts given value into vector at specified element.

Parameters:

  position | An iterator that points to the element where data should be inserted.
  x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert the given value into the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 539 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::begin(), and std::vector< _Tp, _Alloc >::end().

Referenced by std::vector< _Tp, _Alloc >::resize().

template<class _Tp, class _Alloc = allocator<_Tp>>
size_type std::vector< _Tp, _Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the size of the largest possible vector. Definition at line 264 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const`[inline]`

Subscript access to the data contained in the vector.

Parameters:

  n | The element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 300 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::begin().

template<class _Tp, class _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | `[inline]`

Subscript access to the data contained in the vector.

Parameters:

  n | The element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 289 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::begin().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::pop_back | ( |  | ) | `[inline]`

| Removes last element from vector. This is a typical stack operation. It allows us to shrink the vector by one. Note that no data is returned and if last element's data is needed it should be retrieved before pop_back() is called. Definition at line 626 of file stl_vector.h.

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::push_back | ( |  | ) | `[inline]`

Add an element to the end of the vector. The element is default-constructed.

Note:
  You must define _GLIBCPP_DEPRECATED to make this visible; see c++config.h.

Definition at line 508 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::push_back | ( | const _Tp & | __x | ) | `[inline]`

Add data to the end of the vector.

Parameters:

  x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the vector and assigns the given data to it. Due to the nature of a vector this operation can be done in constant time if the vector has preallocated space available.

Definition at line 489 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
const_reverse_iterator std::vector< _Tp, _Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last element in the vector. Iteration is done in reverse element order. Definition at line 240 of file stl_vector.h. References std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
reverse_iterator std::vector< _Tp, _Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last element in the vector. Iteration is done in reverse element order. Definition at line 233 of file stl_vector.h. References std::vector< _Tp, _Alloc >::end().

template<class _Tp, class _Alloc = allocator<_Tp>>
const_reverse_iterator std::vector< _Tp, _Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order. Definition at line 256 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin().

template<class _Tp, class _Alloc = allocator<_Tp>>
reverse_iterator std::vector< _Tp, _Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order. Definition at line 248 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::reserve | ( | size_type | __n | ) | `[inline]`

Attempt to preallocate enough memory for specified number of elements.

Parameters:

  n | Number of elements required

This function attempts to reserve enough memory for the vector to hold the specified number of elements. If the number requested is more than max_size() length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the number of elements that will be required the user can reserve the memory and thus prevent a possible reallocation of memory and copy of vector data.

Definition at line 393 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::capacity(), and std::vector< _Tp, _Alloc >::size().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::resize | ( | size_type | __new_size | ) | `[inline]`

Resizes the vector to the specified number of elements.

Parameters:

  new_size | Number of elements the vector should contain.

This function will resize the vector to the specified number of elements. If the number is smaller than the vector's current size the vector is truncated, otherwise the vector is extended and new elements are left uninitialized.

Definition at line 701 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::resize().

template<class _Tp, class _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | const _Tp & | __x
| ) | `[inline]`

Resizes the vector to the specified number of elements.

Parameters:

  new_size | Number of elements the vector should contain.
  x | Data with which new elements should be populated.

This function will resize the vector to the specified number of elements. If the number is smaller than the vector's current size the vector is truncated, otherwise the vector is extended and new elements are populated with given data.

Definition at line 685 of file stl_vector.h.

References std::vector< _Tp, _Alloc >::begin(), std::vector< _Tp, _Alloc >::end(), std::vector< _Tp, _Alloc >::erase(), std::vector< _Tp, _Alloc >::insert(), and std::vector< _Tp, _Alloc >::size().

Referenced by std::vector< _Tp, _Alloc >::resize().

template<class _Tp, class _Alloc = allocator<_Tp>>
size_type std::vector< _Tp, _Alloc >::size | ( |  | ) | const`[inline]`

| Returns the number of elements in the vector. Definition at line 260 of file stl_vector.h. References std::vector< _Tp, _Alloc >::begin(), and std::vector< _Tp, _Alloc >::end(). Referenced by std::vector< _Tp, _Alloc >::reserve(), and std::vector< _Tp, _Alloc >::resize().

The documentation for this class was generated from the following file:

- stl_vector.h